package com.prank.sound.funnyapp.activity;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.util.Log;
import android.view.View;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.bumptech.glide.Glide;
import com.prank.sound.funnyapp.R;
import com.prank.sound.funnyapp.bean.DbManager;
import com.prank.sound.funnyapp.bean.MyInfo;
import com.prank.sound.funnyapp.databinding.ActivityPlaySoundsBinding;
import com.prank.sound.funnyapp.dialog.DialogStartTimer;
import com.prank.sound.funnyapp.max.MaxManager;
import com.prank.sound.funnyapp.max.onAdAfterAction;
import com.prank.sound.funnyapp.myadapter.AdapterViewAll;
import com.prank.sound.funnyapp.myinterface.OnClickItem;
import com.prank.sound.funnyapp.myinterface.OnClickItemTimer;
import com.prank.sound.funnyapp.mytool.Common;
import com.prank.sound.funnyapp.mytool.Decoration;

import java.io.IOException;
import java.util.List;

public class PlayItemActivity extends AppCompatActivity implements View.OnClickListener, OnClickItemTimer, OnClickItem {

    private ActivityPlaySoundsBinding playBinding;

    private MyInfo info;
    private DialogStartTimer dialogStartTimer;

    private MediaPlayer mediaPlayer;
    private BroadcastReceiver volumeReceiver;
    private CountDownTimer countDownTimer;
    private int color;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        playBinding = ActivityPlaySoundsBinding.inflate(getLayoutInflater());
        setContentView(playBinding.getRoot());
        Common.setStatusBarTextColor(this, true);
        info = (MyInfo) getIntent().getSerializableExtra(Common.KEY_PLAY_DATA);
        color = getIntent().getIntExtra(Common.KEY_LIST_COLOR_POS, 0);
//        playBinding.constraintLayout.setBackground(ContextCompat.getDrawable(this, Tools.playBgs[color]));

        MaxManager.onLoadAd();
        MaxManager.startShowMaxAd(this, new onAdAfterAction() {
            @Override
            public void onAction() {

            }
        });

        initAudio();
        String covert = info.getCovert();
        if (covert != null && !covert.isEmpty()) {
            Glide.with(this).load(covert)
                    .placeholder(R.drawable.def_sounds)
                    .into(playBinding.image);
        } else {
            Glide.with(this).load(R.drawable.def_sounds)
                    .into(playBinding.image);
        }
        playBinding.name.setText(info.getName());
        playBinding.back.setOnClickListener(this);
        playBinding.btnPlay.setOnClickListener(this);
        playBinding.imLike.setOnClickListener(this);
        playBinding.imLoop.setOnClickListener(this);
        playBinding.imTimer.setOnClickListener(this);
        Common.setVolume(this, playBinding.seekbar);

        initLike();
        loadMore();
        volumeReceiver();

    }

    private void stopCountDown() {
        if (countDownTimer != null) {
            countDownTimer.cancel();
        }
    }

    private void startCountDown(long time) {
        stopCountDown();
        countDownTimer = new CountDownTimer(time, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {
            }

            @Override
            public void onFinish() {
                dialogStartTimer.setOffSelected();
                if (!mediaPlayer.isPlaying()) {
                    playBinding.btnPlay.setSelected(true);
                    mediaPlayer.start();
                }
            }
        };
        countDownTimer.start();
    }

    private void volumeReceiver() {
        volumeReceiver = new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                if (intent.getAction().equals("android.media.VOLUME_CHANGED_ACTION")) {
                    AudioManager audioManager = (AudioManager) context.getSystemService(Context.AUDIO_SERVICE);
                    int currentVolume = audioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
                    if (playBinding.seekbar.getProgress() != currentVolume) {
                        playBinding.seekbar.setProgress(currentVolume);
                    }

                }
            }
        };
        IntentFilter filter = new IntentFilter("android.media.VOLUME_CHANGED_ACTION");
        registerReceiver(volumeReceiver, filter);
    }

    private void initLike() {
        Log.d("---------", "--------info=" + info.isLike());
        boolean b = DbManager.checkLike(info);
        playBinding.imLike.setSelected(b);
    }

    private void loadMore() {
        List<MyInfo> more = DbManager.getMore();
        Decoration itemHelper = new Decoration(0, 0, (int) Common.dpToPx(3));
        AdapterViewAll adapterViewAll = new AdapterViewAll(this, more, 1, this);
        playBinding.moreRecycler.setLayoutManager(new LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false));
        playBinding.moreRecycler.setAdapter(adapterViewAll);
        playBinding.moreRecycler.addItemDecoration(itemHelper);
        adapterViewAll.setColorIndex(color);
    }

    private void initAudio() {
        showPlayBtn(false);
        mediaPlayer = new MediaPlayer();
        try {
            mediaPlayer.reset();
            mediaPlayer.setDataSource(info.getAudioUrl());
            mediaPlayer.prepareAsync();
            mediaPlayer.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
                @Override
                public void onPrepared(MediaPlayer mp) {
                    showPlayBtn(true);
                }
            });

            mediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                @Override
                public void onCompletion(MediaPlayer mp) {
                    playBinding.btnPlay.setSelected(false);
                }
            });
        } catch (IOException ioException) {
            showPlayBtn(true);
        }
    }

    private void showPlayBtn(boolean showBtn) {
        if (showBtn) {
            playBinding.btnPlay.setVisibility(View.VISIBLE);
            playBinding.playLoading.setVisibility(View.GONE);
        } else {
            playBinding.btnPlay.setVisibility(View.GONE);
            playBinding.playLoading.setVisibility(View.VISIBLE);
        }
    }


    @Override
    public void onClick(View v) {
        if (v.equals(playBinding.back)) {
            MaxManager.startShowMaxAd(this, new onAdAfterAction() {
                @Override
                public void onAction() {
                    finish();
                }
            });
        } else if (v.equals(playBinding.btnPlay)) {
            boolean selected = playBinding.btnPlay.isSelected();
            if (selected) {
                if (mediaPlayer.isPlaying()) {
                    mediaPlayer.pause();
                }
            } else {
                if (!mediaPlayer.isPlaying()) {
                    mediaPlayer.start();
                }
            }
            playBinding.btnPlay.setSelected(!selected);

        } else if (v.equals(playBinding.imLike)) {
            playBinding.imLike.setSelected(!playBinding.imLike.isSelected());
            boolean selected = playBinding.imLike.isSelected();
            if (selected) {
                info.setColorIndex(color);
                DbManager.addLike(info);
            } else {
                DbManager.removeLike(info);
            }
        } else if (v.equals(playBinding.imLoop)) {
            playBinding.imLoop.setSelected(!playBinding.imLoop.isSelected());
            mediaPlayer.setLooping(playBinding.imLoop.isSelected());
        } else if (v.equals(playBinding.imTimer)) {
            if (dialogStartTimer == null) {
                dialogStartTimer = new DialogStartTimer(PlayItemActivity.this, this);
            }
            dialogStartTimer.showTop(playBinding.imTimer);
        }

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mediaPlayer.isPlaying()) {
            mediaPlayer.stop();
        }
        mediaPlayer.release();
        mediaPlayer = null;
        stopCountDown();
    }

    @Override
    public void onClickTimerListener(long time) {
        dialogStartTimer.hide();
        if (time == -1) {
            stopCountDown();
        } else {
            startCountDown(time);
        }

    }

    @Override
    public void onClickSoundsListener(MyInfo data) {
        Intent intent = new Intent(this, PlayItemActivity.class);
        intent.putExtra(Common.KEY_PLAY_DATA, data);
        startActivity(intent);
        finish();
    }
}